//Ein kleines Beispiel fr die Anwendung von Steganographie mit der LSB-Methode
//Autor: Markus Lange-Hegermann
//Email: MarkusLH@gmx.de, MarkusLH@web.de
//Instant Messages: Markuslh83@hotmail.com, 116891458, 92239400, LangeHeg
//Fr Updates (eher selten): www.Delphi-Treff.de
//Dieses Programm ist Opensource: In meinem verstndnis bedeutet dies, dass
//Freewareprogramme beliebig aus diesem Programm abschreiben knnen (sollte ich
//erwhnt werden) und es weiterentwickeln drfen. Aber jegliche komerzielle
//Nutzung der Quelltexte und seiner Weiterentwicklung ist ohne meine
//audrckliche Erlaubnis Strafbar.

//Diese Unit erhlt die Methoden, um die Farben zu manipulieren
unit UBits;

interface

uses graphics, windows;

//BitManipulation
  //Rckgabewert ist Value, wobei aber anschlieen die Stelle auf jedenfall "1" ist
  function Setze(Value: Byte; Stelle: Byte): Byte;
  //Rckgabewert ist Value, wobei aber anschlieen die Stelle auf jedenfall "0" ist
  function Entferne(Value: Byte; Stelle: Byte): Byte;
  //Gibt den an Stelle stehenden Wert in Value zurck ("1"->true, "0"->false)
  function Erhalte(Value: Byte; Stelle: Byte): boolean;

//FarbManipulation
function GetRed(Color: TColor):Byte;
function GetGreen(Color: TColor):Byte;
function GetBlue(Color: TColor):Byte;
function rgb(Blue,Green,Red: Byte):TColor;

//Bitmapanzeige
  //Gibt aus einem Rechteck mit der Breite "Width" die Koordinaten von Pos zurck
  //Pos=1 ist "Links-Oben", Pos=2 ist "2.VonLinks-Oben", etc.
  function GetPixel(Width, Pos: Integer): TPoint;

implementation

function setze(Value: Byte; Stelle: Byte): Byte;
begin
  case Stelle of
    1: Result:=Value or $80;
    2: Result:=Value or $40;
    3: Result:=Value or $20;
    4: Result:=Value or $10;
    5: Result:=Value or $08;
    6: Result:=Value or $04;
    7: Result:=Value or $02;
    8: Result:=Value or $01;
  else result:=0;
  end;
end;

function Entferne(Value: Byte; Stelle: Byte): Byte;
begin
  case Stelle of
    1: Result:=Value and $7F;
    2: Result:=Value and $BF;
    3: Result:=Value and $DF;
    4: Result:=Value and $EF;
    5: Result:=Value and $F7;
    6: Result:=Value and $FB;
    7: Result:=Value and $FC;
    8: Result:=Value and $FE;
  else Result:=0;
  end;
end;

function Erhalte(Value: Byte; Stelle: Byte): boolean;
begin
  if (Byte(Value shl (Stelle-1))shr 7)=$01
    then Result:=true
    else Result:=false;
end;

function GetBlue(Color: TColor):Byte;
begin
  Result:=(Integer(Color) shl 8) shr 24;
end;

function GetGreen(Color: TColor):Byte;
begin
  Result:=(Integer(Color) shl 16) shr 24;
end;

function GetRed(Color: TColor):Byte;
begin
  Result:=(Integer(Color) shl 24) shr 24;
end;

function rgb(Blue,Green,Red: Byte):TColor;
begin
  Result:=TColor(Integer(Blue) shl 16 + Integer(Green) shl 8 +Integer(Red))
end;

function GetPixel(Width, Pos: Integer): TPoint;
begin
  Result.x:=(Pos-1) mod Width;
  Result.y:=(Pos-1) div Width;
end;

end.
 